#include <sigc++/sigc++.h>
#include "gmref.h"

class B;

class A : public sigc::trackable,
	  public GmRefCounted
{
    public:
        A () {}
    
        void signal_handler (gmref_ptr<B>) {};
};

class B : public sigc::trackable,
	  public GmRefCounted
{
    public:
        B () {}

        sigc::signal<void> MySignal;
};

int
main (int argc, char* argv[])
{
	{
		gmref_ptr<A> a (new A);
		
		{
			gmref_ptr<B> b (new B);

			b->MySignal.connect (sigc::bind (sigc::mem_fun (*(a.get()), &A::signal_handler), b));
		}

	}

	return 0;
}

