#include <boost/shared_ptr.hpp>
#include <boost/weak_ptr.hpp>
#include <sigc++/sigc++.h>

class B;

class A : public sigc::trackable
{
   public:
       A () {}

       void signal_handler (boost::weak_ptr<B>) {};
};

class B : public sigc::trackable
{
   public:
       B () {}

       sigc::signal<void> MySignal;
};

int
main (int argc, char* argv[])
{
   {
       boost::shared_ptr<A> a (new A);

       {
           boost::shared_ptr<B> b (new B);
           boost::weak_ptr<B> c( b ) ;


b->MySignal.connect (sigc::bind (sigc::mem_fun (*(a.get()), &A::signal_handler), c));

       }
   }

   return 0;
}

